package de.jaetzold.art.examples;

import de.jaetzold.art.RobotInterface;

public class AriadneSimpleFTDemoRobot extends AriadneSimpleRobot {

	public AriadneSimpleFTDemoRobot(NormalizedDriveTrain driveTrain) {
		super(driveTrain, -1, 0);
	}
	public AriadneSimpleFTDemoRobot(RobotInterface iface) {
		this(new NormalizedDriveTrainSimpleAlgorithm(
					new NormalizedDriveTrainSimpleFTDemoRobot(iface)
				)
			);
	}
// ...
	public AriadneSimpleFTDemoRobot(String interfacePortName) {
		this(new de.jaetzold.art.RobotInterfaceFactory()
									.getInterface(interfacePortName));
	}
	public AriadneSimpleFTDemoRobot() {
		this(System.getProperty(className +".portName", "FT"));
	}
	private static String className =
			"de.jaetzold.art.examples.AriadneSimpleFTDemoRobot";
	public static void main(String[] argv) {
		if(argv.length > 0) {
			System.setProperty(className +".portName", argv[0]);
		}
		AriadneSimpleAlgorithm.Robot robot = new AriadneSimpleFTDemoRobot();
		AriadneSimpleAlgorithm ariadne = new AriadneSimpleAlgorithm(robot);
		
		AriadneView view = new AriadneView(ariadne);
		AriadneCommands commands = new AriadneCommands(ariadne);
				
		java.awt.Frame f = new java.awt.Frame(className);
		f.setLayout(new java.awt.BorderLayout());
		f.add("North", view);
		f.add("South", commands);
		
		f.addWindowListener(
			new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent we) {
					System.exit(0);
				}
			}
		);
		f.pack();
		f.show();
	}
// ...
}
