package de.jaetzold.art.examples;

import java.awt.Panel;
import java.awt.TextField;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

public class AriadneView extends Panel implements PropertyChangeListener {
	protected TextField stateOutput;
	
	public AriadneView() {
		stateOutput = new TextField("", 15);
		stateOutput.setEditable(false);
		add(stateOutput);
	}
	
	public void propertyChange(PropertyChangeEvent pce) {
		if(pce.getSource() instanceof Ariadne
				&& pce.getPropertyName().equals("state")
				&& pce.getNewValue() instanceof Number) {
			
			String stateName = "";
			switch(((Number)pce.getNewValue()).intValue()) {
				case Ariadne.ORIENTED:
					stateName = "oriented";
					break;
				case Ariadne.ORIENTING:
					stateName = "orienting";
					break;
				default:
					stateName = "";
			}

			stateOutput.setText(stateName);
		}
	}
// ...
	public AriadneView(Ariadne ariadne) {
		this();
		de.jaetzold.util.BeanSupport.addPropertyChangeListenerFor(ariadne, this);
	}
// ...
}
