// BEGIN DriveTrainCommands:construction
package de.jaetzold.art.examples;

import java.awt.Panel;
import java.awt.Button;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class DriveTrainCommands extends Panel {
	public DriveTrainCommands(DriveTrain driveTrain) {
		this();
		setDriveTrain(driveTrain);
	}
	public DriveTrainCommands() {
		Button stop = new Button("stop");
		stop.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					if(dt != null) {
						dt.stop();
					}
				}
			}
		);
		add(stop);
		// ...
		Button resume = new Button("resume");
		resume.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					if(dt != null) {
						dt.resume();
					}
				}
			}
		);
		add(resume);
		
		Button forward = new Button("forward");
		forward.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					if(dt != null) {
						dt.forward();
					}
				}
			}
		);
		add(forward);
		
		Button backward = new Button("backward");
		backward.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					if(dt != null) {
						dt.backward();
					}
				}
			}
		);
		add(backward);
		
		Button left = new Button("spin left");
		left.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					if(dt != null) {
						dt.leftSpin();
					}
				}
			}
		);
		add(left);
		Button right = new Button("spin right");
		right.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					if(dt != null) {
						dt.rightSpin();
					}
				}
			}
		);
		add(right);
		// ...
	}
	
	protected DriveTrain dt;
	public void setDriveTrain(DriveTrain dt) {
		this.dt = dt;
	}
}
// END DriveTrainCommands:construction
