// BEGIN rotation:ft
package de.jaetzold.art.examples;
// ...
import de.jaetzold.art.Sensor;
import de.jaetzold.art.SensorStateDecider;
import de.jaetzold.util.StateDeciderLinkedStateDecider;
import de.jaetzold.util.BinaryOperatorStateDecider;
import de.jaetzold.util.BinaryOperator;
import de.jaetzold.util.Debug;

import java.beans.PropertyVetoException;
// ...
public class FTRotationCountStateDecider
							extends StateDeciderLinkedStateDecider
{
// ...
	private static final Debug debug =
			new Debug("de.jaetzold.art.examples.FTRotationCountStateDecider");
// ...
	public FTRotationCountStateDecider(Sensor directionSensor) {
		try {
			setFirstDecider(new SensorStateDecider( directionSensor,
													true));

			setSecondDecider(
				new BinaryOperatorStateDecider(
					new BinaryOperator() {
						public double combine(  double first,
												double second)
						{
							return Math.abs(first-second);
						}
					},
					true
				)
			);

			setLinkDecider(
				new BinaryOperatorStateDecider(
					new BinaryOperator() {
						private int seq;
						private int last;
						public double combine(  double first,
												double second)
						{
							if(first>0) {
								last = 1;
							} else if(first<0) {
								last = -1;
							} else {
// ...
								if(debug.debug) {
									if(second != 0) {
										seq++;
										debug.printInfo("Have to guess count, seq="
														+seq
														+" - using " +last
														+"*" +second);
									}
								}
// ...
							}
							return last*second;
						}
					},
					true
				)
			);
		} catch(PropertyVetoException pve) {
		}
	}
}
// END rotation:ft
