package de.jaetzold.art.examples;

import de.jaetzold.art.RobotInterfaceFactory;
import de.jaetzold.art.RobotInterface;
import de.jaetzold.art.ActuatorPort;
import de.jaetzold.art.Motor;

public class HelloRobot {
	public static void main(String[] argv) throws InterruptedException {
    	Motor motor = new Motor();

    	// get an interface to the actual hardware
    	RobotInterfaceFactory factory = new RobotInterfaceFactory();
    	RobotInterface hardware = factory.getInterface();

    	// get a port and connect the motor to it (match hardware!)
    	ActuatorPort port = hardware.getActuatorPorts(0);
    	motor.connectWith(port);

    	// turn it on
    	motor.on();

    	// delay and quit
    	Thread.sleep(1000);
	}
}
