package de.jaetzold.art.examples;

import java.awt.Panel;
import java.awt.TextField;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

import de.jaetzold.util.BeanSupport;	// does some reflect-stuff

public class LiSeView	extends		Panel
						implements	PropertyChangeListener
{
	protected TextField stateOutput = new TextField("", 14);
	protected AWTSensorView angleView = new AWTSensorView();
	protected Panel contentPanel = new Panel();
	{
		stateOutput.setEditable(false);
		contentPanel.add(stateOutput);
		contentPanel.add(angleView);
		add(contentPanel);
	}
	
	public LiSeView() {
	}
	
	// not ...-out here because somewhat necessary
	public LiSeView(LiSe lise) {
		BeanSupport.addPropertyChangeListenerFor(lise, this);
		lise.getAngleSensor().addPropertyChangeListener(angleView);
	}
	
	public AWTSensorView getAngleView() {
		return angleView;
	}
	
	public void propertyChange(PropertyChangeEvent pce) {
		if(pce.getSource() instanceof LiSe
				&& pce.getPropertyName().equals("state")
				&& pce.getNewValue() instanceof Number) {
			
			String stateName = "";
			switch(((Number)pce.getNewValue()).intValue()) {
				case LiSe.STOP:
					stateName = "stop";
					break;
				case LiSe.SEARCH:
					stateName = "search";
					break;
				case LiSe.SEE_LEFT:
					stateName = "see left";
					break;
				case LiSe.SEE_RIGHT:
					stateName = "see right";
					break;
				case LiSe.SEE_CENTER:
					stateName = "see center";
					break;
				default:
					stateName = "unknown";
			}

			stateOutput.setText(stateName);
		}
	}
}
