package de.jaetzold.art.examples;

import java.awt.Panel;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.Label;
import java.awt.TextField;
import java.awt.Button;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class NormalizedDriveTrainCommands extends Panel {	
	public NormalizedDriveTrainCommands(NormalizedDriveTrain driveTrain) {
		this();
		setNormalizedDriveTrain(driveTrain);
	}
	public NormalizedDriveTrainCommands() {
		setLayout(new GridLayout(1, 6));
		
		Panel p = new Panel(new BorderLayout());
		add(p);
		p.add("Center", new Label());
		Button stop = new Button("stop");
		stop.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					if(dt != null) {
						dt.stop();
					}
				}
			}
		);
		p.add("South", stop);

		p = new Panel(new BorderLayout());
		add(p);
		p.add("Center", new Label());
		Button resume = new Button("resume");
		resume.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					if(dt != null) {
						dt.resume();
					}
				}
			}
		);
		p.add("South", resume);
		
		final TextField forwardMeters = new TextField("0.0");
		p = new Panel(new BorderLayout());
		add(p);
		p.add("Center", forwardMeters);
		Button forward = new Button("forward");
		forward.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					if(dt != null) {
						try {
							dt.forward(
								Double.parseDouble(forwardMeters.getText()));
						} catch(NumberFormatException nfe) {
							dt.forward();
						}
					}
				}
			}
		);
		p.add("South", forward);
		
		
		final TextField backwardMeters = new TextField("0.0");
		p = new Panel(new BorderLayout());
		add(p);
		p.add("Center", backwardMeters);
		Button backward = new Button("backward");
		backward.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					if(dt != null) {
						try {
							dt.backward(
								Double.parseDouble(backwardMeters.getText()));
						} catch(NumberFormatException nfe) {
							dt.backward();
						}
					}
				}
			}
		);
		p.add("South", backward);
		
		
		final TextField leftAngle = new TextField("0.0");
		p = new Panel(new BorderLayout());
		add(p);
		p.add("Center", leftAngle);
		Button left = new Button("spin left");
		left.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					if(dt != null) {
						try {
							dt.leftSpin(
								Double.parseDouble(leftAngle.getText()));
						} catch(NumberFormatException nfe) {
							dt.leftSpin();
						}
					}
				}
			}
		);
		p.add("South", left);

		
		final TextField rightAngle = new TextField("0.0");
		p = new Panel(new BorderLayout());
		add(p);
		p.add("Center", rightAngle);
		Button right = new Button("spin right");
		right.addActionListener(
			new ActionListener() {
				public void actionPerformed(ActionEvent ae) {
					if(dt != null) {
						try {
							dt.rightSpin(
								Double.parseDouble(rightAngle.getText()));
						} catch(NumberFormatException nfe) {
							dt.rightSpin();
						}
					}
				}
			}
		);
		p.add("South", right);
	}
	
	protected NormalizedDriveTrain dt;
	public void setNormalizedDriveTrain(NormalizedDriveTrain dt) {
		this.dt = dt;
	}
}
