package de.jaetzold.art.examples;

import de.jaetzold.art.RobotInterface;

public class NormalizedDriveTrainSimpleMSDemoRobot
					extends NormalizedDriveTrainSimpleBaseRobot
{
	public NormalizedDriveTrainSimpleMSDemoRobot(RobotInterface iface)
	{
		// turnTime is not linear ... :-(
		super(new DriveTrainSimpleMSDemoRobot(iface), 10500, 4200);
	}
// ...
	public NormalizedDriveTrainSimpleMSDemoRobot(String interfacePortName) {
		this(new de.jaetzold.art.RobotInterfaceFactory()
									.getInterface(interfacePortName));
	}
	public NormalizedDriveTrainSimpleMSDemoRobot() {
		this(System.getProperty(className +".portName", "MS"));
	}
	private static String className =
			"de.jaetzold.art.examples.NormalizedDriveTrainSimpleMSDemoRobot";
	public static void main(String[] argv) {
		if(argv.length > 0) {
			System.setProperty(className +".portName", argv[0]);
		}
		NormalizedDriveTrainSimpleAlgorithm.Robot robot =
							new NormalizedDriveTrainSimpleMSDemoRobot();
		NormalizedDriveTrain driveTrain =
							new NormalizedDriveTrainSimpleAlgorithm(robot);
		
		DriveTrainView view = new DriveTrainView(driveTrain);
		NormalizedDriveTrainCommands commands =
							new NormalizedDriveTrainCommands(driveTrain);
		
		java.awt.Frame f = new java.awt.Frame(className);
		f.setLayout(new java.awt.BorderLayout());
		f.add("North", view);
		f.add("South", commands);
		
		f.addWindowListener(
			new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent we) {
					System.exit(0);
				}
			}
		);
		f.pack();
		f.show();
	}
// ...
}
