package de.jaetzold.art.examples;

import de.jaetzold.util.StateDecider;
import de.jaetzold.util.RangeStateDecider;
import de.jaetzold.util.TransitionMatrixStateDecider;
import de.jaetzold.util.Range;
import de.jaetzold.util.SingleRange;
import de.jaetzold.util.ComplementRange;
import de.jaetzold.util.CombinedRange;
import de.jaetzold.util.DifferenceRange;

import java.beans.PropertyVetoException;

public class RCXRawSwitchStateDecider extends TransitionMatrixStateDecider {
	public RCXRawSwitchStateDecider(Range range0,
									Range range1,
									Range hysteresis) {
		// decider if we're in state 0
		Range range0to0 = new CombinedRange(range0, hysteresis);
		Range range0to1 = new DifferenceRange(range1, range0to0);
		StateDecider decider0 =
				new RangeStateDecider(new Range[] { range0to0, range0to1});
		// decider if we're in state 1
		Range range1to1 = new CombinedRange(range1, hysteresis);
		Range range1to0 = new DifferenceRange(range0, range1to1);
		StateDecider decider1 =
				new RangeStateDecider(new Range[] { range1to0, range1to1});
		
		try {
			setDeciders(new StateDecider[] {decider0, decider1});
		} catch(PropertyVetoException pve) {
			// shouldn't happen for the current superclass-implementation
			throw new IllegalArgumentException(pve.getMessage());
		}
	}
	
	public RCXRawSwitchStateDecider() {
		// set standard RCX-Values
		// for values and hysteresis see gaspari, proudfoot, extreme mindstorms
		this(new SingleRange(512),
			new ComplementRange(new SingleRange(512)),
			new SingleRange(460, 562));
					
	}
}
