package de.jaetzold.art.examples;

import de.jaetzold.util.StateDecider;
import de.jaetzold.util.TransitionMatrixStateDecider;

public class RCXRotationFastCountStateDecider implements StateDecider {
	public boolean isCacheable() {
		return false;
	}
	
	// kann man auch aufspalten in stateSensor fuer turnStates
	// und eine 13x13 countmatrix im countsensor
	// dafuer ware ein stateSensor mit der TurnStateMatrix an
	// einen StateSensor mit dem RCXRotationSensorStateDecider angeschlossen
	private StateDecider countMatrix =
			new TransitionMatrixStateDecider(
				new int[][]{/*  l\n   0, 1, 2, 3, 4	*/
							/*	0*/	{ 0, 0, 0, 0, 0},	//
							
							/*	1*/	{ 0, 0, 1, 0,-1},	// -\
							/*	2*/	{ 0,-1, 0, 1, 0},	//	  turning
							/*	3*/	{ 0, 0,-1, 0, 1},	//	  stopped
							/*	4*/	{ 0, 1, 0,-1, 0},	// -/
							
							/*	5*/	{ 0, 0, 1,-2,-1},	// -\
							/*	6*/	{ 0,-1, 0, 1,-2},	//	  turning
							/*	7*/	{ 0,-2,-1, 0, 1},	//	  negative
							/*	8*/	{ 0, 1,-2,-1, 0},	// -/
							
							/*	9*/	{ 0, 0, 1, 2,-1},	// -\
							/* 10*/	{ 0,-1, 0, 1, 2},	//	  turning
							/* 11*/	{ 0, 2,-1, 0, 1},	//	  positive
							/* 12*/	{ 0, 1, 2,-1, 0}});	// -/
	
	private StateDecider turnStateMatrix =
			new TransitionMatrixStateDecider(
				new int[][]{/*  l\n   0, 1, 2, 3, 4	*/
							/*	0*/	{ 0, 1, 2, 3, 4},	//
							
							/*	1*/	{ 0, 1,10, 3, 8},	// -\
							/*	2*/	{ 0, 5, 2,11, 4},	//	  turning
							/*	3*/	{ 0, 1, 6, 3,12},	//	  stopped
							/*	4*/	{ 0, 8, 2, 7, 4},	// -/
							
							/*	5*/	{ 0, 1,10, 7, 8},	// -\
							/*	6*/	{ 0, 5, 2,11, 8},	//	  turning
							/*	7*/	{ 0, 5, 6, 3,12},	//	  negative
							/*	8*/	{ 0, 9, 6, 7, 4},	// -/
							
							/*	9*/	{ 0, 1,10,11, 8},	// -\
							/* 10*/	{ 0, 5, 2,11,12},	//	  turning
							/* 11*/	{ 0, 9, 6, 3,12},	//	  positive
							/* 12*/	{ 0, 9,10, 7, 4}});	// -/
							
	private double lastTurnState;
	private boolean initializedState;
	public synchronized double nextStateValue(	double lastState,
												double newState)
	{
		if(!initializedState) {
			lastTurnState = lastState;
			initializedState = true;
		}
		double result = countMatrix.nextStateValue(lastTurnState, newState);
		lastTurnState = turnStateMatrix.nextStateValue(lastTurnState, newState);
		return result;
	}
}
