package de.jaetzold.art.examples;

import de.jaetzold.art.LightSensor;
import de.jaetzold.art.RobotInterfaceFactory;
import de.jaetzold.art.RobotInterface;
import de.jaetzold.art.Port;

public class SubsumptionLiSeFTDemoRobot implements SubsumptionLiSe.Robot {
	protected LiSe lise;
	protected LightSensor leftSensor;
	protected LightSensor rightSensor;
	
	public SubsumptionLiSeFTDemoRobot(LiSe lise, RobotInterface iface) {
		this.lise = lise;
		
		Port leftPort = iface.getPort("EX");
		Port rightPort = iface.getPort("EY");
		if(rightPort == null || leftPort == null) {
			throw new IllegalArgumentException("RobotInterface " +iface
												+" provides not the required Ports."
												+"EX=" +leftPort
												+", EY=" +rightPort);
		}
		
		leftSensor = new LightSensor();
		leftSensor.connectWith(leftPort);
		
		rightSensor = new LightSensor();
		rightSensor.connectWith(rightPort);
	}
	
	public LiSe getLiSe() {
		return lise;
	}
	public LightSensor getLeftSensor() {
		return leftSensor;
	}
	public LightSensor getRightSensor() {
		return rightSensor;
	}

	public SubsumptionLiSeFTDemoRobot() throws Exception {
		this((LiSe)Class.forName(
				System.getProperty(
					className +".liseClass",
					"de.jaetzold.art.examples.LiSeSimpleAlgorithm"
				)
			).newInstance(),
			new RobotInterfaceFactory().getInterface(
				new de.jaetzold.art.RobotInterfaceStringDefinition(
					System.getProperty(
						className +".portName",
						"FT"
					)
				)
			)
		);
	}
	private static String className =
			"de.jaetzold.art.examples.SubsumptionLiSeFTDemoRobot";
// ...
	public static void main(String[] argv) throws Exception {
		if(argv.length > 0) {
			System.setProperty(className +".portName", argv[0]);
		}
		new SubsumptionLiSeFTDemoRobot();
	}
// ...
}
	
