package de.jaetzold.art.examples;

import de.jaetzold.art.RobotInterface;

public class TrustySimpleAWTDemoRobot extends TrustySimpleBaseRobot {
	public TrustySimpleAWTDemoRobot(NormalizedDriveTrain driveTrain) {
		super(driveTrain, 0.2, 0.1);
	}
	public TrustySimpleAWTDemoRobot(RobotInterface iface) {
		this(new NormalizedDriveTrainSimpleAlgorithm(
					new NormalizedDriveTrainSimpleAWTDemoRobot(iface)
				)
			);
	}
// ...
	public TrustySimpleAWTDemoRobot(String interfacePortName) {
		this(new de.jaetzold.art.RobotInterfaceFactory()
									.getInterface(interfacePortName));
	}
	public TrustySimpleAWTDemoRobot() {
		this(System.getProperty(className +".portName", "AWT"));
	}
	private static String className =
			"de.jaetzold.art.examples.TrustySimpleAWTDemoRobot";
	public static void main(String[] argv) {
		if(argv.length > 0) {
			System.setProperty(className +".portName", argv[0]);
		}
		TrustySimpleAlgorithm.Robot robot = new TrustySimpleAWTDemoRobot();
		TrustySimpleAlgorithm trusty = new TrustySimpleAlgorithm(robot);
		
		TrustyView view = new TrustyView(trusty);
		TrustyCommands commands = new TrustyCommands(trusty);
				
		java.awt.Frame f = new java.awt.Frame(className);
		f.setLayout(new java.awt.BorderLayout());
		f.add("North", view);
		f.add("South", commands);
		
		f.addWindowListener(
			new java.awt.event.WindowAdapter() {
				public void windowClosing(java.awt.event.WindowEvent we) {
					System.exit(0);
				}
			}
		);
		f.pack();
		f.show();
	}
// ...
}
